#include "Stage.h"
#include "Stages.h"

static const byte[] Bytes0 = {
	(1 << 2) | 1, (13 << 2) | 0, (2 << 2) | 3, (0 << 2) | 2, 
	(3 << 2) | 1, (4 << 2) | 3, (2 << 2) | 0, (0 << 2) | 1, 
	(4 << 2) | 1, (2 << 2) | 3, (0 << 2) | 2, (5 << 2) | 0, 
	(1 << 2) | 1, (11 << 2) | 1, (1 << 2) | 3, (0 << 2) | 1, 
	(9 << 2) | 1, (2 << 2) | 3, (1 << 2) | 0, (7 << 2) | 1, 
	(7 << 2) | 0, 
};

static const byte[] Enemies0 = {
	(0 << 4) | 7,
	(2 << 4) | 3,
	(4 << 4) | 12,
};

static const byte[] Blocks0 = {
	(1 << 4) | 9,
	(3 << 4) | 6,
};

static const byte[] Bytes1 = {
	(9 << 2) | 2, (5 << 2) | 1, (2 << 2) | 1, (2 << 2) | 2, 
	(2 << 2) | 1, (2 << 2) | 1, (3 << 2) | 3, (4 << 2) | 1, 
	(9 << 2) | 3, (0 << 2) | 0, (0 << 2) | 1, (7 << 2) | 1, 
	(6 << 2) | 0, (4 << 2) | 1, (10 << 2) | 1, (9 << 2) | 1, 
	(5 << 2) | 0, (8 << 2) | 1, (6 << 2) | 0, 
};

static const byte[] Enemies1 = {
	(1 << 4) | 0,
	(2 << 4) | 12,
	(5 << 4) | 11,
};

static const byte[] Blocks1 = {
	(2 << 4) | 1,
	(3 << 4) | 10,
};

static const byte[] Bytes2 = {
	(1 << 2) | 3, (1 << 2) | 1, (11 << 2) | 0, (9 << 2) | 2, 
	(0 << 2) | 1, (4 << 2) | 0, (0 << 2) | 1, (4 << 2) | 3, 
	(0 << 2) | 2, (0 << 2) | 3, (0 << 2) | 1, (5 << 2) | 1, 
	(0 << 2) | 0, (2 << 2) | 1, (12 << 2) | 0, (0 << 2) | 1, 
	(2 << 2) | 2, (0 << 2) | 3, (0 << 2) | 1, (4 << 2) | 1, 
	(4 << 2) | 3, (2 << 2) | 1, (7 << 2) | 2, (4 << 2) | 0, 
	(5 << 2) | 1, (9 << 2) | 1, (9 << 2) | 1, (5 << 2) | 0, 
};

static const byte[] Enemies2 = {
	(4 << 4) | 8,
	(5 << 4) | 9,
	(6 << 4) | 3,
};

static const byte[] Blocks2 = {
	(5 << 4) | 12,
	(6 << 4) | 7,
	(7 << 4) | 4,
};

static const byte[] Bytes3 = {
	(7 << 2) | 1, (5 << 2) | 3, (1 << 2) | 0, (4 << 2) | 1, 
	(7 << 2) | 2, (2 << 2) | 0, (3 << 2) | 1, (9 << 2) | 1, 
	(1 << 2) | 0, (4 << 2) | 1, (10 << 2) | 1, (0 << 2) | 1, 
	(8 << 2) | 1, (5 << 2) | 0, (0 << 2) | 3, (10 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (0 << 2) | 0, (1 << 2) | 1, 
	(6 << 2) | 1, (6 << 2) | 1, (0 << 2) | 3, (5 << 2) | 1, 
	(4 << 2) | 1, (3 << 2) | 3, (2 << 2) | 1, (10 << 2) | 1, 
	(1 << 2) | 0, 
};

static const byte[] Enemies3 = {
	(2 << 4) | 9,
	(4 << 4) | 14,
	(5 << 4) | 2,
	(6 << 4) | 12,
	(7 << 4) | 12,
};

static const byte[] Blocks3 = {
	(3 << 4) | 6,
	(5 << 4) | 13,
	(7 << 4) | 7,
};

static const byte[] Bytes4 = {
	(12 << 2) | 1, (2 << 2) | 3, (2 << 2) | 1, (12 << 2) | 0, 
	(6 << 2) | 1, (8 << 2) | 0, (1 << 2) | 1, (4 << 2) | 2, 
	(8 << 2) | 1, (5 << 2) | 1, (4 << 2) | 1, (4 << 2) | 0, 
	(1 << 2) | 1, (4 << 2) | 2, (7 << 2) | 1, (0 << 2) | 3, 
	(3 << 2) | 1, (4 << 2) | 1, (6 << 2) | 0, (0 << 2) | 3, 
	(3 << 2) | 2, (8 << 2) | 1, (1 << 2) | 0, (2 << 2) | 3, 
	(4 << 2) | 1, (7 << 2) | 0, (14 << 2) | 1, (0 << 2) | 0, 
};

static const byte[] Enemies4 = {
	(0 << 4) | 4,
	(3 << 4) | 11,
	(6 << 4) | 5,
	(8 << 4) | 9,
};

static const byte[] Blocks4 = {
	(1 << 4) | 13,
	(4 << 4) | 9,
	(7 << 4) | 6,
	(9 << 4) | 6,
};

static const byte[] Bytes5 = {
	(3 << 2) | 1, (11 << 2) | 0, (0 << 2) | 1, (2 << 2) | 3, 
	(7 << 2) | 1, (3 << 2) | 0, (14 << 2) | 1, (0 << 2) | 0, 
	(4 << 2) | 1, (10 << 2) | 3, (0 << 2) | 3, (0 << 2) | 1, 
	(7 << 2) | 3, (5 << 2) | 0, (1 << 2) | 3, (3 << 2) | 1, 
	(2 << 2) | 2, (2 << 2) | 1, (3 << 2) | 0, (14 << 2) | 1, 
	(0 << 2) | 0, (3 << 2) | 1, (10 << 2) | 1, (0 << 2) | 0, 
	(5 << 2) | 3, (2 << 2) | 1, (6 << 2) | 0, (13 << 2) | 1, 
	(1 << 2) | 0, (1 << 2) | 1, (13 << 2) | 1, 
};

static const byte[] Enemies5 = {
	(1 << 4) | 4,
	(3 << 4) | 0,
	(6 << 4) | 13,
	(7 << 4) | 1,
	(8 << 4) | 6,
	(9 << 4) | 11,
};

static const byte[] Blocks5 = {
	(4 << 4) | 3,
	(9 << 4) | 7,
	(10 << 4) | 6,
};

static const byte[] Bytes6 = {
	(6 << 2) | 1, (8 << 2) | 0, (9 << 2) | 1, (5 << 2) | 0, 
	(3 << 2) | 1, (10 << 2) | 1, (0 << 2) | 0, (11 << 2) | 1, 
	(1 << 2) | 1, (1 << 2) | 0, (1 << 2) | 1, (0 << 2) | 2, 
	(1 << 2) | 1, (10 << 2) | 0, (0 << 2) | 3, (3 << 2) | 1, 
	(10 << 2) | 0, (4 << 2) | 2, (4 << 2) | 1, (5 << 2) | 0, 
	(1 << 2) | 1, (0 << 2) | 2, (0 << 2) | 1, (4 << 2) | 2, 
	(5 << 2) | 1, (0 << 2) | 0, (0 << 2) | 1, (4 << 2) | 2, 
	(0 << 2) | 3, (0 << 2) | 1, (3 << 2) | 1, (3 << 2) | 3, 
	(2 << 2) | 1, (12 << 2) | 0, (6 << 2) | 1, (8 << 2) | 0, 
	(4 << 2) | 1, (10 << 2) | 0, 
};

static const byte[] Enemies6 = {
	(1 << 4) | 5,
	(2 << 4) | 6,
	(4 << 4) | 12,
	(5 << 4) | 9,
	(7 << 4) | 9,
	(8 << 4) | 14,
	(10 << 4) | 8,
};

static const byte[] Blocks6 = {
	(3 << 4) | 2,
	(6 << 4) | 11,
	(9 << 4) | 12,
};

static const byte[] Bytes7 = {
	(12 << 2) | 1, (2 << 2) | 0, (0 << 2) | 1, (1 << 2) | 1, 
	(8 << 2) | 2, (3 << 2) | 0, (0 << 2) | 1, (8 << 2) | 1, 
	(1 << 2) | 2, (2 << 2) | 1, (0 << 2) | 0, (0 << 2) | 1, 
	(8 << 2) | 1, (1 << 2) | 2, (2 << 2) | 1, (0 << 2) | 0, 
	(0 << 2) | 1, (6 << 2) | 1, (6 << 2) | 1, (0 << 2) | 0, 
	(0 << 2) | 3, (7 << 2) | 1, (2 << 2) | 1, (3 << 2) | 0, 
	(1 << 2) | 2, (2 << 2) | 2, (0 << 2) | 3, (6 << 2) | 1, 
	(2 << 2) | 0, (0 << 2) | 1, (0 << 2) | 2, (0 << 2) | 1, 
	(1 << 2) | 2, (2 << 2) | 1, (6 << 2) | 1, (0 << 2) | 0, 
	(0 << 2) | 1, (0 << 2) | 2, (0 << 2) | 1, (6 << 2) | 1, 
	(5 << 2) | 0, (0 << 2) | 1, (12 << 2) | 1, (1 << 2) | 0, 
	(0 << 2) | 1, (2 << 2) | 1, (1 << 2) | 3, (9 << 2) | 0, 
	(10 << 2) | 1, (4 << 2) | 0, (5 << 2) | 1, (6 << 2) | 1, 
	(2 << 2) | 0, 
};

static const byte[] Enemies7 = {
	(0 << 4) | 7,
	(1 << 4) | 5,
	(2 << 4) | 3,
	(3 << 4) | 4,
	(4 << 4) | 9,
	(5 << 4) | 13,
	(7 << 4) | 12,
	(9 << 4) | 5,
	(11 << 4) | 9,
};

static const byte[] Blocks7 = {
	(1 << 4) | 13,
	(4 << 4) | 5,
	(5 << 4) | 4,
	(6 << 4) | 3,
	(8 << 4) | 6,
	(10 << 4) | 2,
	(12 << 4) | 2,
};

static const byte[] Bytes8 = {
	(9 << 2) | 2, (5 << 2) | 1, (0 << 2) | 3, (0 << 2) | 1, 
	(5 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, (5 << 2) | 1, 
	(5 << 2) | 1, (1 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, 
	(4 << 2) | 1, (0 << 2) | 0, (5 << 2) | 1, (0 << 2) | 3, 
	(0 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, (3 << 2) | 1, 
	(1 << 2) | 0, (0 << 2) | 3, (0 << 2) | 1, (5 << 2) | 2, 
	(0 << 2) | 1, (0 << 2) | 2, (4 << 2) | 1, (0 << 2) | 0, 
	(4 << 2) | 1, (2 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, 
	(0 << 2) | 1, (4 << 2) | 0, (1 << 2) | 1, (1 << 2) | 3, 
	(3 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, (4 << 2) | 1, 
	(0 << 2) | 0, (1 << 2) | 1, (5 << 2) | 2, (0 << 2) | 1, 
	(0 << 2) | 2, (4 << 2) | 1, (0 << 2) | 0, (1 << 2) | 1, 
	(5 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, (4 << 2) | 1, 
	(0 << 2) | 0, (4 << 2) | 1, (2 << 2) | 2, (0 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (3 << 2) | 0, (4 << 2) | 1, 
	(2 << 2) | 2, (0 << 2) | 1, (0 << 2) | 2, (3 << 2) | 1, 
	(1 << 2) | 0, (5 << 2) | 1, (1 << 2) | 2, (0 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (3 << 2) | 0, (3 << 2) | 1, 
	(3 << 2) | 2, (0 << 2) | 1, (5 << 2) | 1, (0 << 2) | 0, 
	(4 << 2) | 1, (10 << 2) | 0, 
};

static const byte[] Enemies8 = {
	(1 << 4) | 10,
	(2 << 4) | 1,
	(3 << 4) | 12,
	(6 << 4) | 11,
	(7 << 4) | 4,
	(8 << 4) | 11,
	(10 << 4) | 5,
};

static const byte[] Blocks8 = {
	(2 << 4) | 11,
	(4 << 4) | 11,
	(9 << 4) | 12,
	(11 << 4) | 2,
};

static const byte[] Bytes9 = {
	(11 << 2) | 1, (3 << 2) | 3, (9 << 2) | 1, (2 << 2) | 2, 
	(2 << 2) | 0, (9 << 2) | 1, (2 << 2) | 3, (0 << 2) | 2, 
	(1 << 2) | 1, (6 << 2) | 1, (2 << 2) | 2, (3 << 2) | 2, 
	(1 << 2) | 1, (1 << 2) | 1, (4 << 2) | 1, (2 << 2) | 3, 
	(0 << 2) | 2, (1 << 2) | 1, (0 << 2) | 2, (1 << 2) | 1, 
	(1 << 2) | 1, (4 << 2) | 2, (3 << 2) | 2, (1 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (4 << 2) | 1, (2 << 2) | 2, 
	(1 << 2) | 1, (0 << 2) | 2, (1 << 2) | 1, (0 << 2) | 2, 
	(1 << 2) | 1, (4 << 2) | 1, (2 << 2) | 2, (1 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (0 << 2) | 2, (1 << 2) | 1, 
	(2 << 2) | 1, (6 << 2) | 1, (0 << 2) | 2, (1 << 2) | 1, 
	(0 << 2) | 2, (1 << 2) | 1, (5 << 2) | 1, (4 << 2) | 3, 
	(1 << 2) | 1, (0 << 2) | 2, (1 << 2) | 1, (6 << 2) | 1, 
	(8 << 2) | 1, (5 << 2) | 1, (1 << 2) | 3, (7 << 2) | 0, 
	(10 << 2) | 1, (4 << 2) | 0, (2 << 2) | 1, (12 << 2) | 0, 
	(1 << 2) | 1, (13 << 2) | 0, 
};

static const byte[] Enemies9 = {
	(0 << 4) | 8,
	(1 << 4) | 5,
	(2 << 4) | 3,
	(4 << 4) | 2,
	(6 << 4) | 2,
	(9 << 4) | 2,
	(11 << 4) | 0,
	(13 << 4) | 9,
};

static const byte[] Blocks9 = {
	(1 << 4) | 13,
	(2 << 4) | 5,
	(3 << 4) | 10,
	(5 << 4) | 7,
	(10 << 4) | 2,
	(12 << 4) | 3,
	(14 << 4) | 12,
};

const Stage[] Stages = {
	{
		6, Bytes0,
		3, Enemies0,
		2, Blocks0,
	},
	{
		7, Bytes1,
		3, Enemies1,
		2, Blocks1,
	},
	{
		8, Bytes2,
		3, Enemies2,
		3, Blocks2,
	},
	{
		9, Bytes3,
		5, Enemies3,
		3, Blocks3,
	},
	{
		10, Bytes4,
		4, Enemies4,
		4, Blocks4,
	},
	{
		11, Bytes5,
		6, Enemies5,
		3, Blocks5,
	},
	{
		12, Bytes6,
		7, Enemies6,
		3, Blocks6,
	},
	{
		13, Bytes7,
		9, Enemies7,
		7, Blocks7,
	},
	{
		14, Bytes8,
		7, Enemies8,
		4, Blocks8,
	},
	{
		15, Bytes9,
		8, Enemies9,
		7, Blocks9,
	},
};
