include 'Vram.inc'
include 'VVram.inc'

ext VVram_
ext Chars_, Ascii_
ext PollVSync_

dseg
Backup:
    defs VVramWidth*VVramHeight

cseg
; VVramToVram();
VVramToVram_: public VVramToVram_
    push af | push hl | push de | push bc | push ix | push iy
        ld hl,VVram_
        ld de,Backup
        ld c,VVramHeight
        exx
            ld hl,VramTop
            ld c,0
        exx
        ld iy,VramTop + VramCharWidth ; pointer of attribute
        do
            push hl
                ex de,hl
                    ld b,VVramWidth
                    do
                        ld a,(de)
                        cp (hl)
                        if nz
                            ld (hl),a
                            exx
                                inc c
                            exx
                        endif
                        inc de
                        inc hl
                    dwnz
                ex de,hl
            pop hl
            exx
                ld a,c
            exx
            or a
            if nz
                call PollVSync_
                push bc
                    exx
                        ld de, VramAttrWidth/2 - 1 ; d = last attribute, e = attribute count
                        ld c, 0 ; column
                    exx
                    ld b, VVramWidth
                    do
                        ld a,(hl)   ; char code
                        inc hl
                        push hl
                            ld l,a
                            ld h,0
                            add hl,hl
                            add hl,hl
                            ex de,hl
                                ld ix,Chars_
                                add ix,de
                            ex de,hl
                        pop hl
                        exx
                            ld b,2
                            do
                                ld a,(ix)
                                inc ix
                                ld (hl),a
                                inc hl
                                ld a,e ; attribute count
                                or a
                                ld a,(ix)   ; new attribute
                                inc ix
                                if nz
                                    cp d ; last attribute
                                    if nz
                                        ld (iy),c ; column
                                        inc iy
                                        ld (iy),a ; current attribute
                                        inc iy
                                        dec e ; attribute count
                                        ld d,a ; update current attribute
                                    endif
                                endif
                                inc c ; column
                            dwnz
                        exx
                    dwnz
                    exx
                        ld c,VVramWidth * 2 ; column
                        ld (iy),c ; column
                        inc iy
                        ld (iy),0f8h ; current attribute
                        inc iy
                        ld c,VramCharWidth
                        ld a,e
                        or a
                        do | while nz
                            ld (iy),c ; column
                            inc iy
                            ld (iy),0f8h ; current attribute
                            inc iy
                            dec e   ; attribute count
                        wend
                        ld bc, VramCharWidth-VVramWidth*2+VramAttrWidth
                        add hl,bc
                    exx
                    ld bc,VramCharWidth
                    add iy,bc
                pop bc
            else
                push bc
                    ld bc, VVramWidth
                    add hl, bc
                pop bc
                exx
                ld bc,VramWidth
                add iy,bc
                add hl,bc
                exx
            endif
                                _deb: public _deb
            dec c
        while nz | wend
    pop iy | pop ix | pop bc | pop de | pop hl | pop af
ret    


;   void ClearScreen();
ClearScreen_: public ClearScreen_
    push af | push hl | push bc
        ld hl,Vram
        ld c,VramHeight
        do
            ld b,VramCharWidth
            xor a
            do
                ld (hl),a
                inc hl
            dwnz
            ld (hl),0
            inc hl
            ld (hl),0f8h
            inc hl
            ld b,VramAttrWidth/2-1
            do
                ld (hl),VramCharWidth
                inc hl
                ld (hl),0f8h
                inc hl
            dwnz
            dec c
        while nz | wend

        ld hl,VVram_
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,b
            or c
        while nz | wend

        ld hl,Backup
        ld bc,VVramWidth*VVramHeight
        do
            ld (hl),0
            inc hl
            dec bc
            ld a,b
            or c
        while nz | wend
    pop bc | pop hl | pop af
ret


;   ptr<byte> PrintC(ptr<byte> address, byte c);
PrintC_: public PrintC_
    push af
    push bc
        ld a,e
        ex de,hl
            sub ' '
            add a,a
            add a,a
            ld c,a | ld b,0
                ld hl,Ascii_
                add hl,bc
            ld bc,2
            ldir
            push de
                ex de,hl
                ld bc,VramWidth-2
                add hl,bc
                ex de,hl
                ld bc,2
                ldir
            pop de
        ex de,hl
    pop bc
    pop af
ret 


;   ptr<byte> Put(ptr<byte> pVram, byte c);
Put_: public Put_
    push af
    push hl
    push de
    push bc
        ex de,hl
            ld h,0
            add hl,hl   ; *2
            add hl,hl   ; *4
            ld bc,Chars_
            add hl,bc
        ex de,hl
        ld b,2
        do
            ld a,(de)
            inc de
            inc de
            ld (hl),a
            inc hl
        dwnz
    pop bc
    pop de
    pop hl
    pop af
    inc hl | inc hl |
ret
